
;TV's server version 3.00
;Copyright (c) 2014, Tycho Veltmeijer.
;All rights reserved.


;64 BIT Equ's
ClearSpaceForAPI     equ 8*16
UsedSizeBydEnter     equ 0x1C*2
FunctionReturnFactor equ 0
scasp equ scasq
movsp equ movsq
jpcxz equ jrcxz



psize	    equ 8
pointer     equ dq
pdword	    equ qword
peax	    equ rax
pecx	    equ rcx
pebx	    equ rbx
pedx	    equ rdx
pedi	    equ rdi
pesi	    equ rsi
pebp	    equ rbp
pesp	    equ rsp

;nonvolatile values
nvecx	    equ r12
nvedx	    equ r13

;nonvolatile values
nvecxd	     equ r12d
nvedxd	     equ r13d


;With this you can use the macro 'if used is64'
virtual at 0
call is64
is64:
end virtual

;With this you can use the macro 'if used isLinux'
virtual at 0
call isLinux
isLinux:
end virtual


macro StartProc num
{ common

pop rax

if num = 6
   push r9
end if
if num = 5 | num = 6
   push r8
end if
if num = 4 | num = 5 | num = 6
   push rcx
end if
if num = 3 | num = 4 | num = 5 | num = 6
   push rdx
end if
if num = 2 | num = 3 | num = 4 | num = 5 | num = 6
   push rsi
end if

push rdi

push rax
}

macro EndProc num
{common

      add rsp,(num*psize)+psize
      push qword [rsp-((num*psize)+psize)] ;push return address
}

macro ClearStack
{ common
  ;add rsp,ClearSpaceForAPI
  ;undoFixStack
}

macro undoFixStack
{ common
  add rsp,qword [rsp]
  add rsp,8
}

macro MakeStack
{ common

  fixStack 0
  sub rsp,ClearSpaceForAPI

}

macro fixStack pushAnnyway
{ common
  local ..unevenStack
  local ..dontPush

  mov rax,rsp

  shr rax,4
  if pushAnnyway=1
    jc ..unevenStack

    push 0

    ..unevenStack:
    rcr rax,1
    shr rax,29+31
    xor eax,8
    push rax
  else
    jnc ..dontPush

    push 0

    ..dontPush:
  end if
}

macro argpush num,arg
{ common

if arg eqtype 0
	size@arg = 8
       else if arg eqtype byte 0
	virtual at 0
	 mov [rbx],arg
	 local opcode
	 load opcode byte from 0
	 if opcode and 0F8h = 48h
	  size@arg = 8
	 else if opcode = 66h
	  size@arg = 2
	 else if opcode = 0C7h
	  size@arg = 4
	 else
	  size@arg = 1
	 end if
	end virtual
       else
	virtual at 0
	 inc arg
	 local opcode
	 load opcode byte from 0
	 if opcode = 67h
	  load opcode byte from 1
	 end if
	 if opcode and 0F8h = 48h
	  size@arg = 8
	 else if opcode = 66h
	  size@arg = 2
	 else if opcode = 0FFh
	  size@arg = 4
	 else
	  size@arg = 1
	 end if
	end virtual
       end if

    if size@arg = 8
       if num = 1
	  if arg eq rdi
	  else
	     mov rdi,arg
	  end if
       else
	  if num = 2
	     if arg eq rsi
	     else
		mov rsi,arg
	     end if
	  else
	     if num = 3
		if arg eq rdx
		else
		  mov rdx,arg
		end if

	     else
		if num = 4
		   if arg eq rcx
		   else
			mov rcx,arg
		   end if
		else
		  if num = 5
		     if arg eq r8
		     else
			mov r8,arg
		     end if
		  else
		    if num = 6
		       if arg eq r9
		       else
			  mov r9,arg
		       end if
		    else
		       push arg
		    end if
		  end if
		end if
	     end if
	   end if
       end if
    end if

    if size@arg = 4
       if num = 1
	  mov edi,arg
       else
	  if num = 2
	     mov esi,arg
	  else
	     if num = 3
		mov rdx,arg
	     else
		if num = 4
		   mov rcx,arg
		else
		  if num = 5
		     mov r8d,arg
		  else
		    if num = 6
		      mov r9d,arg
		    else
		      push 0
		      mov dword [rsp],arg
		    end if
		  end if
		end if
	     end if
	   end if
       end if
    end if

    if size@arg = 2
       mov dword [rsp],arg
    end if

    if size@arg = 1
       mov dword [rsp],arg
    end if
}

macro argpop num,arg
{ common

       if num = 1
	  mov arg,rcx
       else
	  if num = 2
	     mov arg,rdx
	  else
	     if num = 3
		mov arg,r8
	     else
		if num = 4
		   mov arg,r9
		else
		   mov arg,qword [rsp+((num-1)*8)]
		end if
	     end if
	   end if
       end if

}

macro argpushsys num,arg
{ common
       if num = 1
	  if arg eq rdi
	  else
	     mov rdi,arg
	  end if
       else
	  if num = 2
	     if arg eq rsi
	     else
		mov rsi,arg
	     end if
	  else
	     if num = 3
		if arg eq rdx
		else
		  mov rdx,arg
		end if

	     else
		if num = 4
		   if arg eq r10
		   else
			mov r10,arg
		   end if
		 else
		    if num = 5
		       if arg eq r8
		       else
			    mov r8,arg
		       end if
		    else
		       if num = 6
			  if arg eq r9
			  else
				mov r9,arg
			  end if
		       else
			    mov qword [rsp+((num-1)*8)],arg
		       end if
		    end if
		end if
	     end if
	   end if
       end if
}

macro linuxCall num, num32
{ common
  mov rax,num
  syscall
}

macro argpop num,arg
{ common

       if num = 1
	  mov arg,rcx
       else
	  if num = 2
	     mov arg,rdx
	  else
	     if num = 3
		mov arg,r8
	     else
		if num = 4
		   mov arg,r9
		else
		   mov arg,qword [rsp+((num-1)*8)]
		end if
	     end if
	   end if
       end if

}

if used denter
	denter:
	pop rax
	push rdi
	push rsi
	push rbx
	push rdx
	push rcx
	push r12
	push r13
	push r14
	push r15
	push rbp

	mov rbp,rsp
	add rbp,0x24*2
	jmp rax
end if

if used dleave
	dleave:
	pop rcx
	mov rsp,rbp
	sub rsp,0x24*2
	push rcx
	add rsp,0x4*2
	pop rbp
	pop r15
	pop r14
	pop r13
	pop r12
	pop rcx
	pop rdx
	pop rbx
	pop rsi
	pop rdi
	jmp qword [rsp-0x58]
end if

if used saveVolatileRegister
macro saveVolatileRegister {
    ;mov r12,rcx
    ;mov r13,rdx
}
end if

if used restoreVolatileRegister
macro restoreVolatileRegister {
    ;mov rcx,r12
    ;mov rdx,r13
}
end if

macro lodsp {
   lodsq
}

macro stosp {
   stosq
}



