
;TV's server version 3.00
;Copyright (c) 2014, Tycho Veltmeijer.
;All rights reserved.

RIGHT_READ equ 0x1
RIGHT_WRITE equ 0x2
RIGHT_EXECUTE equ 0x4

PROT_READ	equ 0x1
PROT_WRITE	equ 0x2
PROT_EXEC	equ 0x4
PROT_SEM	equ 0x8
PROT_NONE	equ 0x0
PROT_GROWSDOWN	equ 0x01000000
PROT_GROWSUP	equ 0x02000000

MAP_SHARED	equ 0x01
MAP_PRIVATE	equ 0x02	
MAP_TYPE	equ 0x0f	
MAP_FIXED	equ 0x10	
MAP_ANONYMOUS	equ 0x20
MAP_GROWSDOWN	equ 0x100
MAP_STACK	equ 1024


DONT_COPY_OLD_DATA equ 0x1

;------------------------------------------------------------------------------
;This function will make a new reallocable memory location with the required size 1:mem location
;------------------------------------------------------------------------------
if used GetMemLocationReAlloc
GetMemLocationReAlloc:
end if

;------------------------------------------------------------------------------
;This function will make a new memory location with the required size 1:mem location
;------------------------------------------------------------------------------
if used GetMemLocation
  GetMemLocation:
  call denter
  MakeStack

  _getpagesize
  mov pecx,peax

  ;align memory
  mov peax,pdword [pebp+(psize*2)]
  add peax,psize
  mov pesi,peax

  xor edx,edx
  div pecx

  sub pecx,pedx
  add pesi,pecx
  mov pdword [pebp+(psize*2)],pesi

argpushsys 6,0 ;offset
argpushsys 5,-1 ;fd
argpushsys 4,0x22;MAP_PRIVATE ;flags
argpushsys 3,PROT_READ or PROT_WRITE ;IPPROTO_TCP or IPPROTO_UDP
argpushsys 2,pesi ;lenngth
argpushsys 1,0 ;addr
linuxCall 9,192  ;sys_mmap2

;set size
mov pesi,pdword [pebp+(psize*2)]
mov pdword [peax],pesi
add peax,psize

  call dleave
  ret (psize*1)
end if

;------------------------------------------------------------------------------
;This function will free a reallocable memory location 1:mem location
;------------------------------------------------------------------------------
if used FreeMemLocationReAlloc
  FreeMemLocationReAlloc:
end if

;------------------------------------------------------------------------------
;This function will free a memory location 1:mem location
;------------------------------------------------------------------------------
if used FreeMemLocation
  FreeMemLocation:
  ;call denter
  ;MakeStack

  ;mov pecx,pdword [pebp+(psize*2)]
  ;jpcxz NothingToFree

  ;push 0

  ;push pesp
  ;push 0
  ;push pecx
  ;call doesVMLocationExistsEx

  ;pop peax
  ;test peax,peax
  ;jz NothingToFree
  ;jmp UnsafeFreeMemLocation

FuncUnsafeFreeMemLocation:
  call denter
  MakeStack

  mov  pedi,pdword [pebp+(psize*2)]
  sub pedi,psize

;UnsafeFreeMemLocation:

  argpushsys 2,pdword [pedi]
  argpushsys 1,pedi
  linuxCall 11,91  ;munmap

  NothingToFree:
  call dleave
  ret (psize*1)
end if


;------------------------------------------------------------------------------
;This function will resize the memory if necessary, but will not restore the current data 1:original mem location 2:required space
;------------------------------------------------------------------------------
if used ReSizeMem
ReSizeMem:
	xor eax,eax
	inc eax
	xchg peax,pdword [pesp+psize*2] ;xchange required space with one (flag DONT_COPY_OLD_DATA)
	xchg peax,pdword [pesp+psize]	;xchange original mem location with required space
	xchg peax,pdword [pesp] 	;xchange return address  with original mem location
	push peax			;push return address
	jmp ReAllocMemEx
end if

;------------------------------------------------------------------------------
;This function will resize the memory if necessary 1:original mem location 2:required space
;------------------------------------------------------------------------------
if used ReAllocMem
ReAllocMem:
	xor eax,eax
	xchg peax,pdword [pesp+psize*2] ;xchange required space with zero (flag COPY_DATA)
	xchg peax,pdword [pesp+psize]	;xchange original mem location with required space
	xchg peax,pdword [pesp] 	;xchange return address  with original mem location
	push peax			;push return address
	jmp ReAllocMemEx
end if

;------------------------------------------------------------------------------
;This function will resize the memory if necessary 1:original mem location 2:required space 3:flags
;Flags:
;COPY_DATA 0x0
;DONT_COPY_OLD_DATA 0x1
;------------------------------------------------------------------------------
if used ReAllocMemEx
	ReAllocMemEx:
	call denter

	;load original adress of (r/e)si and the required size on (r/e)dx
	mov pesi,pdword [pebp+psize*2]
	mov pedx,pdword [pebp+psize*3]

	;Get the size of the current memory
	push 0

	push pesp
	push RIGHT_READ
	push pesi
	call doesVMLocationExistsEx

	pop pecx ;the original size

	;check if there is already sufficient space, return
	cmp pecx,pedx
	cmovae peax,pesi
	jae endReAllocMem

	;get a new (bigger) memory location
	push pedx
	call GetMemLocation
	mov pedi,peax
	mov pebx,peax

	test dword [pebp+psize*4],1
     jnz dontCopyOldData

	;copy the old data to the new pointer
	rep movsb

	dontCopyOldData:
	;release the original memory
	push pdword [pebp+psize*2]
	call FreeMemLocationReAlloc

	mov peax,pebx

	endReAllocMem:
	call dleave
	ret psize*3
end if

;------------------------------------------------------------------------------
;This function will resize the destination to the size of the source memory and copy the data
;1:destination mem location
;2:source mem location
;------------------------------------------------------------------------------
if used cpyMemAndRealoc
	cpyMemAndRealoc:
	call denter

	;load original adress of (r/e)si and the required size on (r/e)dx
	mov pesi,pdword [pebp+psize*3] ;source
	mov pedi,pdword [pebp+psize*2] ;destination
	mov pebx,pedi		       ;EBX = destination

	;Get the size of the source
	push 0

	push pesp
	push RIGHT_READ
	push pesi
	call doesVMLocationExistsEx

	pop pecx ;the original size

	;Get the size of destination
	push 0

	push pesp
	push RIGHT_READ
	push pedi
	call doesVMLocationExistsEx

	pop pedx ;the original size

	;check if there is already sufficient space, return
	cmp pecx,pedx
	cmovae peax,pesi
	jae copyTheSourceToDestination

	;resize the destination
	push pecx
	push pedi
	call ReSizeMem
	mov pebx,peax	;EBX = destination
	mov pedi,peax	;EDI = destination

	copyTheSourceToDestination:
	;copy the old data to the new pointer
	rep movsb

	mov peax,pebx

	endcpyMemAndRealoc:
	call dleave
	ret psize*2
end if

;------------------------------------------------------------------------------
;This function will check if the VM location exists and check the rights:
;int doesVMLocationExists(mem:void*, requiredRights:int)
;requiredRights can be:
;---RIGHT_READ 0x1
;---RIGHT_WRITE 0x2
;---RIGHT_EXECUTE 0x4
;------------------------------------------------------------------------------
if used doesVMLocationExists
   doesVMLocationExists:
   xor eax,eax
   xchg peax,pdword [pesp+psize*2] ;xchange requiredRights with zero (return value for size)
   xchg peax,pdword [pesp+psize]   ;xchange mem with requiredRights
   xchg peax,pdword [pesp]	   ;xchange return address with mem
   push peax			   ;push return address
   jmp doesVMLocationExistsEx
end if

;------------------------------------------------------------------------------
;This function will check if the VM location exists and check the rights:
;int doesVMLocationExistsEx(mem:void*, requiredRights:int, *size:int)
;requiredRights can be:
;---RIGHT_READ 0x1
;---RIGHT_WRITE 0x2
;---RIGHT_EXECUTE 0x4
;------------------------------------------------------------------------------
if used doesVMLocationExistsEx
   doesVMLocationExistsEx:
   push pecx

    mov peax,pdword [pesp+psize*2]   ;mem
    mov pecx,pdword [pesp+psize*4] ;*size
    jecxz endDoesVMLocationExistsEx

    ;set size param
    mov peax,pdword [peax-psize]
    mov dword [pecx],eax

   endDoesVMLocationExistsEx:
   xor eax,eax
   inc eax

   pop pecx
   ret psize*3
end if