
;TV's server version 3.00
;Copyright (c) 2014, Tycho Veltmeijer.
;All rights reserved.

;----------------------------------------------------
;                      LaunchCGI
;Launches CGI executable, send POST-command to CGI-application and send the header and result to the client
;
;input:
;    1:ProtocolSession
;    2:ClientSession
;    3:Pointer to a string with the CGI_path
;    4:Pointer to a string with the Enviroment
;    5:buffer size
;    6:Meximum timeout CGI-application
;    7:Pointer to a HTTPSession structure
;    8:Pointer to a ResponseHeader structure

;
;output: (R/E)AX: True/False
;
;----------------------------------------------------
LaunchCGI:
call denter
;Create space on stack:
;--psize*3: SECURITY_ATTRIBUTES
;--psize*2: Return value for CreatePipe "CGI return Pipe"
;--psize*2: Return value for CreatePipe "Pipe For Post Command"
;--(...)  : StartupInfo
;--(psize*2+4*2): PROCESS_INFORMATION
sub pesp,psize*3 + psize*2 + psize*2 + (psize + psize*3 + 8*4 + psize + psize*4) + (psize*2+4*2)
mov pebx,pesp ;save stack pointer
MakeStack

;--Fill in SECURITY_ATTRIBUTES--
mov dword [pebx],psize*3   ;set nLength
mov pdword [pebx+psize],0  ;set lpSecurityDescriptor
mov dword [pebx+psize*2],1 ;set bInheritHandle

;--Create CGI return Pipe--
argpush 4,0	     ;nSize
argpush 3,pebx	     ;lpPipeAttributes
lea pedx,pdword [pebx+psize*3]
argpush 2,pedx	     ;hWritePipe
lea pecx,pdword [pebx+psize*4]
argpush 1,pecx	     ;hReadPipe
call [CreatePipe]
test eax,eax
jz endLaunchCGI

;--Creating Pipe For Post Command--
argpush 4,0	     ;nSize
argpush 3,pebx	     ;lpPipeAttributes
lea pedx,pdword [pebx+psize*5]
argpush 2,pedx	     ;hWritePipe
lea pecx,pdword [pebx+psize*6]
argpush 1,pecx	     ;hReadPipe
call [CreatePipe]
test eax,eax
jz endLaunchCGIDeleteCGIPipe

;--Fill in StartupInfo--
lea pedi,pdword [pebx+psize*7] ;(R/E)DI => pointer to StartupInfo
mov ecx,(psize + psize*3 + 8*4 + psize + psize*4)
xor al,al
rep stosb ;zero StartupInfo
lea pedi,pdword [pebx+psize*7] ;(R/E)DI => pointer to StartupInfo

mov pdword [pedi],(psize + psize*3 + 8*4 + psize + psize*4) ;set cb

mov pecx,pdword [pebx+psize*6]	;hReadPipe
mov pdword [pedi+psize + psize*3 + 8*4 + psize + psize],pecx ;set hStdInput

mov pecx,pdword [pebx+psize*3] ;hWritePipe
mov pdword [pedi+psize + psize*3 + 8*4 + psize + psize*2],pecx ;set hStdOutput
mov pdword [pedi+psize + psize*3 + 8*4 + psize + psize*3],pecx ;set hStdError

mov dword [pedi+psize + psize*3 + 7*4],STARTF_USESHOWWINDOW  or STARTF_USESTDHANDLES ;set dwFlags  ;

lea pesi,pdword [pebx+16*psize+8*4] ;(R/E)SI => pointer to PROCESS_INFORMATION

;Start CGI-application
argpush 10,pesi 		     ;Process Info
argpush 9,pedi			     ;Startup Info
argpush 8,0			     ;Working directory
if used is32
  argpush 7,pdword [pebp+psize*5]    ;Environment
else
  mov pecx,pdword [pebp+psize*5]
  argpush 7,pecx		     ;Environment
end if
argpush 6,0			     ;Flags
argpush 5,1			     ;Use Handle(s)
argpush 4,pebx			     ;SECURITY_ATTRIBUTES
argpush 3,pebx			     ;SECURITY_ATTRIBUTES
argpush 2,0			     ;COMMANDLINE
argpush 1,pdword [pebp+psize*4]      ;CGI-APP
call [CreateProcessA]
test eax,eax
jz endLaunchCGIDeletePostPipe

mov pedx,pdword [pebp+psize*9] ;(R/E)DX => ResponeHeader
or dword [pedx],FRH_DONT_END_HEADER or FRH_DONT_SEND_CONTENT_TYPE ;add flags

;delete FRH_CONNECTION_KEEP_ALIVE flags
test dword [pedx],FRH_CONNECTION_KEEP_ALIVE
jz dontKeepConnectionAlive

  xor dword [pedx],FRH_CONNECTION_KEEP_ALIVE

dontKeepConnectionAlive:
;check if a part of the POST command is in the buffer existing in HTTPSession
mov pedx,pdword [pebp+psize*8] ;(R/E)DX => HTTPSession
mov ecx,dword [pedx+psize*7+4] ;ECX => headerRestSize

jecxz noPostCommandInBuffer

  mov peax,pdword [pedx+psize*4] ;buffer
  if used is32
    add eax,dword [pedx+psize*7]  ;add headerSize to get pointer to headerRest
  else
    mov edx,dword [pedx+psize*7]  ;EDX => headerSize
    add rax,rdx 		  ;add headerSize to get pointer to headerRest
  end if

  ;Write this POST command
  lea pedx,pdword [pebx+psize*7] ;(R/E)DI => Reuse the pointer to StartupInfo for lpNumberOfBytesWritten

  argpush 5,0			  ;lpOverlapped
  argpush 4,pedx		  ;lpNumberOfBytesWritten
  argpush 3,pecx		  ;nNumberOfBytesToWrite
  argpush 2,peax		  ;lpBuffer
  argpush 1,pdword [pebx+psize*5] ;hWritePipe
  call [WriteFile]

noPostCommandInBuffer:
;--;receive the size of one page
;--call GetSmallestPortionPageAllocation
mov eax,dword [pebp+psize*6] ;buffersize

if used is32
  mov ecx,eax ;ECX = size of buffer
else
  mov r12,rax ;r12 => size of buffer
end if

;allocate buffer
push peax
call GetMemLocation
mov pedi,peax ;(R/E)DI => pointer to buffer

if used is32
  sub ecx,4	       ;substract the four bytes used by size of buffer integer
  mov dword [pedi],ecx ;dword [edi] = size of buffer
  add pedi,4	       ;dword [edi-4] = size of buffer
end if

call [GetTickCount]
if used is32
  mov pdword [pebx+psize*9],eax ;(Reuse third member StartupInfo for the TickCount
else
  mov r13d,eax			;r13 => tickCount
end if

waitForInput:
  argpush 1,10
  call [Sleep] ;Wait for 10 miliseconds

  mov edx,dword [pebp+psize*7] ;EDX => maximum timeout
  test edx,edx
  jz unlimitedExecutionTime

    call [GetTickCount]
    mov edx,dword [pebp+psize*7] ;EDX => maximum timeout
    if used is32
      sub eax,pdword [pebx+psize*9] ;Tickcount - privious timeout => time CGI-application is running
    else
      sub eax,r13d		    ;Tickcount - privious timeout => time CGI-application is running
    end if
    cmp eax,edx
    ja timeoutReached

  unlimitedExecutionTime:
  mov pedx,pdword [pebp+psize*8] ;(R/E)DX => HTTPSession
  mov pedx,pdword [pedx]	 ;(R/E)DX => defaultVariables
  mov pedx,pdword [pedx+psize]	 ;EDX => method
  cmp dword [pedx],'POST'	 ;check if method is POST
  jne noPostCommand
    if used is32
      push dword [edi-4]       ;len
    else
      push r12		       ;len
    end if

    push pesp					;&len
    push pedi					;buf
    push 100					;timeout
    push RSF_RETURN_ON_FIRST_SUCCESSFUL_ATTEMPT ;flags
    push pdword [pebp+psize*3]			;ClientSession
    push pdword [pebp+psize*2]			;ProtocolSession
    call [RecvData]
    test eax,eax
    jz noRecvError

    cmp eax,3
    jbe timeoutReached

  noRecvError:
    pop peax ;Received data (len)

    test peax,peax
    jz noPostCommand
    ;jmp noPostCommand

    lea pecx,pdword [pebx+psize*7] ;(R/E)DI => Reuse the pointer to StartupInfo for lpNumberOfBytesWritten

    argpush 5,0 		    ;lpOverlapped
    argpush 4,pecx		    ;lpNumberOfBytesWritten
    argpush 3,peax		    ;nNumberOfBytesToWrite
    argpush 2,pedi		    ;lpBuffer
    argpush 1,pdword [pebx+psize*5] ;hWritePipe
    call [WriteFile]

  noPostCommand:

  argpush 2,0			  ;HighSize
  argpush 1,pdword [pebx+psize*4] ;hReadPipe
  call [GetFileSize]
  test eax,eax
  jnz ReadBuffer

  lea pecx,pdword [pebx+psize*7] ;(R/E)DI => Reuse the pointer to StartupInfo for GetExitProcess

  argpush 2,pecx	  ;lpExitCode
  argpush 1,pdword [pesi]  ;hProcess
  call [GetExitCodeProcess]

  mov ecx,dword [pebx+psize*7] ;ExitCode

  cmp ecx,103h ;STILL_ACTIVE
je waitForInput
jmp endLaunchCGIDeleteBufferEndProcessHandles

ReadBuffer:
  ;if(lenBuf<FileSize) FileSize=lenBuf;
  if used is32
    cmp dword [edi-4],eax
    jae dontChangeReadSize

      mov eax,dword [edi-4]

    dontChangeReadSize:
  else
    cmp r12,rax
    cmovb rax,r12
  end if

  lea pecx,pdword [pebx+psize*7] ;(R/E)DI => Reuse the pointer to StartupInfo for lpNumberOfBytesRead

  argpush 5,0			  ;lpOverlapped
  argpush 4,pecx		  ;lpNumberOfBytesRead
  argpush 3,peax		  ;nNumberOfBytesToRead
  argpush 2,pedi		  ;lpBuffer
  argpush 1,pdword [pebx+psize*4] ;hReadPipe
  call [ReadFile]

  cmp pdword [pebp+psize*9],0 ;ResponseHeader is set to zero is the header is send
  je HeaderIsAlreadySend
    ;mov eax,0x0A0D0A0D ;two new lines
    mov pdword [pebx+psize*8],0 ;(Reuse second member StartupInfo for the pointer that is set to zero for the Status
    mov pecx,pdword [pebx+psize*7]   ;lpNumberOfBytesRead
    mov pedx,pedi ;(R/E)DX => pointer to buffer
    mov peax,pedi ;(R/E)AX => pointer to buffer

    loopBuffer:
      cmp pecx,4 ;check if size of bufer > 4
      jb endHeaderReached

      cmp dword [pedx],0x0A0D0A0D ;check on new lines
      je endHeaderReached

      cmp byte [pedx],':'
      jne nextLoopBuffer

	mov byte [pedx],0x00 ;set zero byte on ':' location

	;generate hash from the name
	push peax ;push for function GenerateHashCaseInsensitiveSafe

	;find next next new line
	mov peax,pedx ;(R/E)AX => location of ':'

	findNewLine:
	  cmp ecx,2
	  jb endFindNewLine

	  cmp word [pedx],0x0A0D
	  je FoundNewLine

	  inc pedx
	loop findNewLine

      endFindNewLine:
	add pesp,psize ;remove the push for GenerateHashCaseInsensitiveSafe
	jmp endHeaderReached

      FoundNewLine:
	;swap pointer to ':' and the pointer for function GenerateHashCaseInsensitiveSafe
	xchg peax,pdword [pesp]
	push peax    ;repush for function GenerateHashCaseInsensitiveSafe
	call GenerateHashCaseInsensitiveSafe
	cmp eax,0x45AF5DAD   ;hash of 'status'

	pop peax
	mov byte [peax],':' ;set ':' back on it's location

	jne findNextNewLine

	  inc peax ;skip ':'
	  skipSpaces:
	    cmp byte [peax],' '
	    jne endSkipSpaces

	    inc peax
	  endSkipSpaces:

	  mov byte [pedx],0
	  mov pdword [pebx+psize*8],pedx  ;(Second member of StartupInfo) => pointer to replaced 0x0D byte

	  mov pedx,pdword [pebp+psize*9] ;(R/E)DX => response header
	  mov pdword [pedx+8],peax	 ;set status code
	  jmp endHeaderReached


	findNextNewLine:
	mov peax,pedx
	add peax,2 ;skip new line and send pointer to fname of CGI-variable

    nextLoopBuffer:
      inc pedx
    loop loopBuffer

  endHeaderReached:
    push DEFAULT_SENDTIMEOUT   ;timeout
    push pdword [pebp+psize*9] ;ResponseHeader
    push pdword [pebp+psize*3] ;ClientSession
    push pdword [pebp+psize*2] ;ProtocolSession
    call [SendHTTPHeader]

    mov peax,pdword [pebx+psize*8] ;(R/E)AX => pointer to replaced 0x0D byte
    test peax,peax
    jz statusWasNotSet

      mov byte [peax],0x0D	     ;place the byte back
    statusWasNotSet:

    mov pdword [pebp+psize*9],0    ;zero responseHeader

  HeaderIsAlreadySend:
  lea peax,pdword [pebx+psize*7]
  push peax		     ;&len
  push pedi		      ;buffer
  push DEFAULT_SENDTIMEOUT    ;timeout
  push RSF_RETURN_ON_COMPLETE ;flags
  push pdword [pebp+psize*3]  ;ClientSession
  push pdword [pebp+psize*2]  ;ProtocolSession
  call [SendData]
  test eax,eax
  jnz timeoutReached

jmp waitForInput

timeoutReached:
  ;terminate the CGI-application
  argpush 2,0		   ;return code
  argpush 1,pdword [pesi]  ;hProcess
  call [TerminateProcess]

endLaunchCGIDeleteBufferEndProcessHandles:
;Free buffer
if used is32
  lea ecx,dword [edi-4]
  push ecx
else
  push rdi
end if
call FreeMemLocation

;close handle hThread
argpush 1,pdword [pesi+psize] ;hThread
call [CloseHandle]

;close handle hProcess
argpush 1,pdword [pesi] ;hProcess
call [CloseHandle]

endLaunchCGIDeletePostPipe:
argpush 1,pdword [pebx+psize*6] ;hReadPipe (CGI return Pipe)
call [CloseHandle]

argpush 1,pdword [pebx+psize*5] ;hWritePipe (CGI return Pipe)
call [CloseHandle]

endLaunchCGIDeleteCGIPipe:
argpush 1,pdword [pebx+psize*4] ;hReadPipe (CGI return Pipe)
call [CloseHandle]

argpush 1,pdword [pebx+psize*3] ;hWritePipe (CGI return Pipe)
call [CloseHandle]

endLaunchCGI:
call dleave
ret psize*8