
;TV's server version 3.00
;Copyright (c) 2014, Tycho Veltmeijer.
;All rights reserved.

;------------------------------------------------------------------------------
;Returns the commandline
;param:

;Return an commandline as ASCII string
;-----------------------------------------------------------------------------
if used getCommandLine
  getCommandLine:
  call denter
  MakeStack

  call [GetCommandLineA]

  call dleave
  ret
end if

;------------------------------------------------------------------------------
;This function return the time the system is running in miliseconds
;param:

;Return runtime in miliseconds
;-----------------------------------------------------------------------------
if used getTickCount
  getTickCount:
  call denter
  MakeStack

  call [GetTickCount]

  call dleave
  ret
end if

;------------------------------------------------------------------------------
;This function will return the Thread id of the currrent thread
;return: Thread Id
;-----------------------------------------------------------------------------
if used getCurThreadid
   getCurThreadid:
   call denter
   MakeStack

   call [GetCurrentThreadId]

   call dleave
   ret
end if

;------------------------------------------------------------------------------
;This function will exit the process
;param:
;    1:Exit code
;return: Thread Id
;-----------------------------------------------------------------------------
if used exitProcess
exitProcess:
  call denter
  MakeStack

  argpush 1,pdword [pebp+psize*2] ;exit code
  call [ExitProcess]
  in al,20h  ;This code should never be executed!!
end if

macro endCreatedThread
{ common
}

macro endThread
{ common
}
;------------------------------------------------------------------------------
;This function will set the thread in WAIT position for x miliseconds
;param:
;  mili: the time in miliseconds to be in WAIT pos
;-----------------------------------------------------------------------------

if used sleep
   sleep:
   call denter
   MakeStack

   argpush 1,pdword [pebp+(psize*2)]
   call [Sleep]

   call dleave
   ret psize
end if

if used createthread
;------------------------------------------------------------------------------
;This function will create a new thread with one parameter
;param:
;  base:  the base address to start the thread
;  param: the parameter passed to the thread
;return: ThreadId or zero in failure
;-----------------------------------------------------------------------------
createthread:
call denter

push 0
mov pebx,pesp

MakeStack

;Create new treath
argpush 6,pebx			   ;the id of the new treath
argpush 5,0
argpush 4,pdword [pebp+psize*3]    ;The parameter for the function
argpush 3,pdword [pebp+psize*2]    ;base adress
argpush 2,0
argpush 1,0
call [CreateThread]		   ;Create the new treath

argpush 1,peax
call [CloseHandle]

mov peax,pdword [pebx] ;The ThreadId

call dleave
ret psize*2

getTEB:
if used is32
  mov edx,dword [FS:0x04]
else
  mov rdx,qword [GS:0x08]
end if
ret
end if